"""A router product type."""

from orchestrator.domain.base import SubscriptionModel
from orchestrator.types import SubscriptionLifecycle

from gso.products.product_blocks.router import (
    RouterBlock,
    RouterBlockInactive,
    RouterBlockProvisioning,
)


class RouterInactive(SubscriptionModel, is_base=True):
    """An inactive router."""

    router: RouterBlockInactive


class RouterProvisioning(RouterInactive, lifecycle=[SubscriptionLifecycle.PROVISIONING]):
    """A router that is being provisioned."""

    router: RouterBlockProvisioning


class Router(RouterProvisioning, lifecycle=[SubscriptionLifecycle.ACTIVE]):
    """A router that is currently active."""

    router: RouterBlock


class ImportedRouterInactive(SubscriptionModel, is_base=True):
    """An imported, inactive router."""

    router: RouterBlockInactive


class ImportedRouter(ImportedRouterInactive, lifecycle=[SubscriptionLifecycle.ACTIVE]):
    """An imported router that is currently active."""

    router: RouterBlock
